library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity Adder is
	generic(W : integer := 8);
	port(Sigma : in std_logic;
		A, B : in std_logic_vector(W - 1 downto 0);
		O : out std_logic_vector(W - 1 downto 0);
		Cout : out std_logic);
end Adder;

architecture Behavioral of Adder is

component FullAdder
	port(A, B, Cin : in std_logic; --Girişler
		O, Cout : out std_logic);	 --Çıkışlar
end component;
	signal Carry : std_logic_vector(W downto 0);
	
	signal BxorSigma : std_logic_vector(W downto 0);
begin
	
	 with Sigma select
	   BxorSigma <= B when '0',
	                not(B) when others;
	
	U1 : for i in 0 to W - 1 generate
		U1 : FullAdder
			port map(A(i), BxorSigma(i), Carry(i), O(i), Carry(i + 1));
	end generate;

	Cout <= Carry(W);
	
	Carry(0) <= Sigma;
	
end Behavioral;