library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;

entity ArithmeticShifter is
	port(DataIn : in std_logic_vector(15 downto 0);
		i : in std_logic_vector(3 downto 0);
		DataOut : out std_logic_vector(15 downto 0));
end ArithmeticShifter;

architecture Behavioral of ArithmeticShifter is

component ShiftCore
	port(DataIn : in std_logic_vector(15 downto 0);
			N, Offset : in std_logic_vector(3 downto 0);
			DataOut : out std_logic);
end component;
		
	type signal_array is array (15 downto 0) of std_logic_vector(15 downto 0);
	signal IB : signal_array;
	
	signal BarrelOut : std_logic_vector(15 downto 0);
	signal AndOut : std_logic_vector(15 downto 0);
	
begin
		
	U1 : for j in 0 to 15 generate
		U2 : ShiftCore
			port map(DataIn, i, std_logic_vector(to_unsigned(j, 4)), BarrelOut(j));
	end generate;
	
	
	with i select
		AndOut <= X"FFFF" when X"0",
					 X"7FFF" when X"1",
					 X"3FFF" when X"2",
					 X"1FFF" when X"3",
					 X"0FFF" when X"4",
					 X"07FF" when X"5",
					 X"03FF" when X"6",
					 X"01FF" when X"7",
					 X"00FF" when X"8",
					 X"007F" when X"9",
					 X"003F" when X"A",
					 X"001F" when X"B",
					 X"000F" when X"C",
					 X"0007" when X"D",
					 X"0003" when X"E",
					 X"0001" when others;
					 
	DataOut <= BarrelOut and AndOut;
	
	
	U3 : for j in 0 to 15 generate
		U4: for k in j to 15 generate
			IB(j)(k) <= DataIn(k);
		end generate;
	end generate;
	
--	U5 : for j in 1 to 15 generate
--		U6: for k in 0 to j - 1  generate
--			IB(j)(15 - k) <= '0';
--		end generate;
--	end generate;
	
--   process
--	begin
--		for j in 0 to 15 loop
--			for k in 0 to 15 loop
--				if (j + k) < 16 then
--					IB(j)(k) <= DataIn(k);
--				else
--					IB(j)(k) <= '0';
--				end if;
--			end loop;
--		end loop;
--	end process;
	
	
		
end Behavioral;