library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity Reg is
	generic(ResetValue : std_logic_vector(15 downto 0) := X"0000");
	port(Clk, Reset : in std_logic;
		DataIn : in std_logic_vector(15 downto 0);
		DataOut : out std_logic_vector(15 downto 0));
end Reg;

architecture Behavioral of Reg is

begin
	
	process(Reset, Clk)
	begin
		if Reset = '1' then
			DataOut <= ResetValue;
		elsif rising_edge(Clk) then
			DataOut <= DataIn;
		end if;
	end process;
	
end Behavioral;