library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.std_logic_signed.all; 
USE ieee.numeric_std.ALL; 

entity ShiftCore is
	port(DataIn : in std_logic_vector(15 downto 0);
		N, Offset : in std_logic_vector(3 downto 0);
		DataOut : out std_logic);
end ShiftCore;

architecture Behavioral of ShiftCore is
	
component Adder
	generic(W : integer := 8);
	port(Sigma : in std_logic;
		A, B : in std_logic_vector(W - 1 downto 0);
		O : out std_logic_vector(W - 1 downto 0));
end component;	
	
	signal Index : std_logic_vector(3 downto 0);
	
begin
	
	U1 : Adder
		generic map(4)
		port map('0', N, Offset, Index);
	
	DataOut <= DataIn(to_integer(unsigned(Index)));
	
end Behavioral;